# coding: utf-8

"""
    Intrinio API

    Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://docs.intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.  # noqa: E501

    OpenAPI spec version: 2.101.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from intrinio_sdk.models.option import Option  # noqa: F401,E501
from intrinio_sdk.models.option_synthetic_greeks_realtime import OptionSyntheticGreeksRealtime  # noqa: F401,E501


class ApiResponseOptionsGreekContractRealtime(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'messages': 'list[str]',
        'option': 'Option',
        'greeks': 'OptionSyntheticGreeksRealtime'
    }

    attribute_map = {
        'messages': 'messages',
        'option': 'option',
        'greeks': 'greeks'
    }

    def __init__(self, messages=None, option=None, greeks=None):  # noqa: E501
        """ApiResponseOptionsGreekContractRealtime - a model defined in Swagger"""  # noqa: E501

        self._messages = None
        self._option = None
        self._greeks = None
        self.discriminator = None

        if messages is not None:
            self.messages = messages
        if option is not None:
            self.option = option
        if greeks is not None:
            self.greeks = greeks

    @property
    def messages(self):
        """Gets the messages of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501

        Any messages or warnings about the data  # noqa: E501

        :return: The messages of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501
        :rtype: list[str]
        """
        return self._messages
        
    @property
    def messages_dict(self):
        """Gets the messages of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501

        Any messages or warnings about the data as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The messages of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501
        :rtype: list[str]
        """

        result = None

        value = self.messages
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'messages': value }

        
        return result
        

    @messages.setter
    def messages(self, messages):
        """Sets the messages of this ApiResponseOptionsGreekContractRealtime.

        Any messages or warnings about the data  # noqa: E501

        :param messages: The messages of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501
        :type: list[str]
        """

        self._messages = messages

    @property
    def option(self):
        """Gets the option of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501


        :return: The option of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501
        :rtype: Option
        """
        return self._option
        
    @property
    def option_dict(self):
        """Gets the option of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501


        :return: The option of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501
        :rtype: Option
        """

        result = None

        value = self.option
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'option': value }

        
        return result
        

    @option.setter
    def option(self, option):
        """Sets the option of this ApiResponseOptionsGreekContractRealtime.


        :param option: The option of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501
        :type: Option
        """

        self._option = option

    @property
    def greeks(self):
        """Gets the greeks of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501


        :return: The greeks of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501
        :rtype: OptionSyntheticGreeksRealtime
        """
        return self._greeks
        
    @property
    def greeks_dict(self):
        """Gets the greeks of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501


        :return: The greeks of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501
        :rtype: OptionSyntheticGreeksRealtime
        """

        result = None

        value = self.greeks
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'greeks': value }

        
        return result
        

    @greeks.setter
    def greeks(self, greeks):
        """Sets the greeks of this ApiResponseOptionsGreekContractRealtime.


        :param greeks: The greeks of this ApiResponseOptionsGreekContractRealtime.  # noqa: E501
        :type: OptionSyntheticGreeksRealtime
        """

        self._greeks = greeks

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiResponseOptionsGreekContractRealtime):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
